<!DOCTYPE html>
<html>
  <head>
    <meta
      charset="utf-8"
      name="viewport"
      content="width=device-width, initial-scale=1"
    />
    <link
      rel="stylesheet"
      href="https://maxcdn.bootstrapcdn.com/bootstrap/4.5.2/css/bootstrap.min.css"
    />
    <link
      rel="stylesheet"
      href="https://cdnjs.cloudflare.com/ajax/libs/font-awesome/4.7.0/css/font-awesome.min.css"
    />
    <script src="https://ajax.googleapis.com/ajax/libs/jquery/3.6.0/jquery.min.js"></script>
    <script src="https://maxcdn.bootstrapcdn.com/bootstrap/4.5.2/js/bootstrap.min.js"></script>

    <!-- Import DataTable Library -->
    <link
      rel="stylesheet"
      href="https://cdn.datatables.net/1.13.6/css/dataTables.bootstrap4.min.css"
    />
    <script src="https://cdn.datatables.net/1.13.6/js/jquery.dataTables.min.js"></script>
    <script src="https://cdn.datatables.net/1.13.6/js/dataTables.bootstrap4.min.js"></script>

    <style>
      th {
        background-color: #5b9ad4;
        color: white;
      }

      table {
        background-color: #d3dfef;
      }

      tr:nth-child(odd) > td {
        background-color: #f7f8fa;
      }

      th,
      td {
        border: 1px solid white;
      }
    </style>
  </head>

  <body>
    <div class="container">
      <!-- <div class="form-group">
        <pre>
        - Định nghĩa 03 đối tượng students (sinh viên), subjects (môn học) và grades (bảng điểm)
        - Điền dữ liệu mẫu cho 03 đối tượng trên. 
            + Student điền 5 sinh viên
            + Subject điền 5 môn học
            + Grades: điền 10 kết quả học tập cho các sinh viên và môn học ở trên
        - Thực hiện load dữ liệu bảng điểm (grades)
        - Thêm bộ lọc theo 2 ô select: Student và Subject
      </pre
        >
      </div> -->

      <div class="text-center mt-2 mb-2">
        <h2>F200 - Lịch sử học tập</h2>
      </div>
      <div class="jumbotron container">
        <div class="row form-group">
          <div class="col-sm-5">
            <div class="row">
              <div class="col-sm-3 p-0 text-right">
                <label>Student</label>
              </div>
              <div class="col-sm-9">
                <select id="select-student" class="form-control">
                  <option value="0">Chọn sinh viên</option>
                </select>
              </div>
            </div>
          </div>

          <div class="col-sm-5">
            <div class="row">
              <div class="col-sm-3 p-0 text-right">
                <label>Subject</label>
              </div>
              <div class="col-sm-9">
                <select id="select-subject" class="form-control">
                  <option value="0">Chọn môn học</option>
                </select>
              </div>
            </div>
          </div>

          <div class="col-sm-2">
            <button id="btn-filter-grade" class="btn btn-info">
              Lọc dữ liệu
            </button>
          </div>
        </div>
      </div>

      <div class="container">
        <table
          class="table table-bordered table-striped table-hover"
          id="study-table"
        >
          <thead>
            <tr>
              <th>STT</th>
              <th>Student</th>
              <th>Môn học</th>
              <th>Điểm</th>
              <th>Ngày thi</th>
            </tr>
          </thead>
        </table>
      </div>
    </div>
  </body>
</html>

<script>
  "use strict";
  /*** REGION 1 - Global variables - Vùng khai báo biến, hằng số, tham số TOÀN CỤC */
  /* Mảng userObjects là mảng chứa dữ liệu user. Từng phần tử là object
   */
  var gStudents = [
    {
      id: 2, // tự tăng
      studentCode: "1356783",
      firstname: "Ngo Van",
      lastname: "Quan",
      age: 18,
      email: "quan@gmail.com",
      studyYear: 2015,
    },
    {
      id: 3, // tự tăng
      studentCode: "1356784",
      firstname: "Ngo",
      lastname: "Quang",
      age: 20,
      email: "quang@gmail.com",
      studyYear: 2020,
    },
    {
      id: 4, // tự tăng
      studentCode: "1356785",
      firstname: "Le",
      lastname: "Minh",
      age: 18,
      email: "minh@gmail.com",
      studyYear: 2021,
    },
    {
      id: 5, // tự tăng
      studentCode: "1356786",
      firstname: "Ly",
      lastname: "Hoa",
      age: 19,
      email: "hoa@gmail.com",
      studyYear: 2022,
    },
    {
      id: 6, // tự tăng
      studentCode: "1356787",
      firstname: "Nguyen",
      lastname: "Quynh",
      age: 19,
      email: "quynh@gmail.com",
      studyYear: 2023,
    },
    {
      id: 7, // tự tăng
      studentCode: "1356788",
      firstname: "Nguyen",
      lastname: "Quynh Mai",
      age: 18,
      email: "mai@gmail.com",
      studyYear: 2020,
    },
  ];

  var gSubjects = [
    {
      id: 5, // tự tăng
      subjectCode: "MATH101",
      subjectName: "Toán cao cấp 1",
    },
    // điền thêm 04 môn học nữa
    {
      id: 6, // tự tăng
      subjectCode: "MATH102",
      subjectName: "Toán cao cấp 2",
    },
    {
      id: 7, // tự tăng
      subjectCode: "MATH103",
      subjectName: "Toán cao cấp 3",
    },
    {
      id: 8, // tự tăng
      subjectCode: "MATH104",
      subjectName: "Toán cao cấp 4",
    },
    {
      id: 9, // tự tăng
      subjectCode: "MATH105",
      subjectName: "Toán cao cấp 5",
    },
    {
      id: 10, // tự tăng
      subjectCode: "MATH106",
      subjectName: "Toán cao cấp 6",
    },
  ];

  var gGrades = [
    {
      id: 2, // tự tăng
      studentId: 2,
      subjectId: 5,
      grade: 8,
      examDate: "13/04/2021",
    },
    // điền thêm 9 kết quả thi nữa
    {
      id: 3, // tự tăng
      studentId: 5,
      subjectId: 10,
      grade: 9,
      examDate: "13/04/2022",
    },
    {
      id: 4, // tự tăng
      studentId: 4,
      subjectId: 5,
      grade: 8,
      examDate: "13/05/2022",
    },
    {
      id: 5, // tự tăng
      studentId: 5,
      subjectId: 9,
      grade: 8.5,
      examDate: "13/06/2022",
    },
    {
      id: 6, // tự tăng
      studentId: 7,
      subjectId: 8,
      grade: 5,
      examDate: "13/07/2022",
    },
    {
      id: 7, // tự tăng
      studentId: 3,
      subjectId: 7,
      grade: 6,
      examDate: "13/08/2022",
    },
    {
      id: 8, // tự tăng
      studentId: 6,
      subjectId: 6,
      grade: 10,
      examDate: "13/09/2022",
    },
    {
      id: 9, // tự tăng
      studentId: 7,
      subjectId: 7,
      grade: 9,
      examDate: "13/10/2022",
    },
    {
      id: 10, // tự tăng
      studentId: 2,
      subjectId: 7,
      grade: 7,
      examDate: "13/11/2022",
    },
    {
      id: 11, // tự tăng
      studentId: 6,
      subjectId: 5,
      grade: 8,
      examDate: "13/12/2022",
    },
    {
      id: 12, // tự tăng
      studentId: 3,
      subjectId: 8,
      grade: 8,
      examDate: "17/11/2022",
    },
  ];
  var gStt = 1;
  /*** REGION 2 - Vùng gán / thực thi hàm xử lý sự kiện cho các elements */
  onPageLoading();

  $("#btn-filter-grade").on("click", function () {
    onBtnFilterGradeClick();
  });
  /*** REGION 3 - Event handlers - Vùng khai báo các hàm xử lý sự kiện */
  function onPageLoading() {
    renderTable();
    renderSelectStudent();
    renderSelectSubject();
  }
  /*** REGION 4 - Common funtions - Vùng khai báo hàm dùng chung trong toàn bộ chương trình*/
  // Hàm load dữ liệu vào bảng
  function renderTable() {
    $("#study-table").DataTable({
      data: gGrades,
      columns: [
        { data: "stt" },
        { data: "studentId" },
        { data: "subjectId" },
        { data: "grade" },
        { data: "examDate" },
      ],
      columnDefs: [
        {
          targets: 0,
          render: function (data) {
            return gStt++;
          },
        },
        {
          targets: 1,
          render: function (data) {
            var vFound = false;
            var vFoundName = "";
            var vI = 0;
            while (!vFound && vI < gStudents.length) {
              if (gStudents[vI].id == data) {
                vFoundName =
                  gStudents[vI].firstname + " " + gStudents[vI].lastname;
                vFound = true;
              } else {
                vI++;
              }
            }
            return vFoundName;
          },
        },
        {
          targets: 2,
          render: function (data) {
            var vFound = false;
            var vFoundName = "";
            var vI = 0;
            while (!vFound && vI < gSubjects.length) {
              if (gSubjects[vI].id == data) {
                vFoundName = gSubjects[vI].subjectName;
                vFound = true;
              } else {
                vI++;
              }
            }
            return vFoundName;
          },
        },
      ],
    });
  }

  // hàm load dữ liệu vào ô Select Student
  function renderSelectStudent() {
    for (var bIndex = 0; bIndex < gStudents.length; bIndex++) {
      $("#select-student").append(
        `<option value = "${gStudents[bIndex].id}">${
          gStudents[bIndex].firstname + " " + gStudents[bIndex].lastname
        }</option>`
      );
    }
  }

  // hàm load dữ liệu vào ô Select Subject
  function renderSelectSubject() {
    for (var bIndex = 0; bIndex < gSubjects.length; bIndex++) {
      $("#select-subject").append(
        `<option value = "${gSubjects[bIndex].id}">${gSubjects[bIndex].subjectName}</option>`
      );
    }
  }

  //hàm thực thi khi nhấn nút Lọc dữ liệu
  function onBtnFilterGradeClick() {
    var vFilterObj = {
      student: "",
      subject: "",
    };

    //B1: thu thập dữ liệu
    readData(vFilterObj);
    //B3: tìm kiếm và hiển thị dữ liệu
    var vFilteredGrades = findGradeByFilter(vFilterObj);
    if (vFilteredGrades.length > 0) {
      alert("Tìm thấy " + vFilteredGrades.length + " kết quả phù hợp!");
      console.log(vFilteredGrades);
      gStt = 1;
      var gStudyTable = $("#study-table").DataTable();
      gStudyTable.clear();
      gStudyTable.rows.add(vFilteredGrades);
      gStudyTable.draw();
    } else {
      alert("Không tìm thấy kết quả phù hợp!");
      return false;
    }
  }

  //hàm thu thập dữ liệu để lọc
  function readData(paramFilterObj) {
    paramFilterObj.student = $("#select-student").val();
    paramFilterObj.subject = $("#select-subject").val();
  }

  //hàm lọc dữ liệu
  function findGradeByFilter(paramFilterObj) {
    var vGrades = [];
    var vStudentId = parseInt(paramFilterObj.student);
    var vSubjectId = parseInt(paramFilterObj.subject);

    if (paramFilterObj.student !== "0" && paramFilterObj.subject !== "0") {
      for (let bI = 0; bI < gGrades.length; bI++) {
        const bGradeObj = gGrades[bI];
        if (
          vStudentId === bGradeObj.studentId &&
          vSubjectId === bGradeObj.subjectId
        ) {
          vGrades.push(bGradeObj);
        }
      }
    }

    if (paramFilterObj.student !== "0" && paramFilterObj.subject === "0") {
      for (let bI = 0; bI < gGrades.length; bI++) {
        const bGradeObj = gGrades[bI];
        if (vStudentId === bGradeObj.studentId) {
          vGrades.push(bGradeObj);
        }
      }
    }

    if (paramFilterObj.student === "0" && paramFilterObj.subject !== "0") {
      for (let bI = 0; bI < gGrades.length; bI++) {
        const bGradeObj = gGrades[bI];
        if (vSubjectId === bGradeObj.subjectId) {
          vGrades.push(bGradeObj);
        }
      }
    }

    if (paramFilterObj.student === "0" && paramFilterObj.subject === "0") {
      vGrades = gGrades;
    }

    return vGrades;
  }
</script>
